<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
            <el-form-item label-width="120px" prop="orgIndex" v-if="userInfoVO.userType == '00'">
                <el-select v-model="queryParams.orgIndex" placeholder="请选择" clearable>
                    <el-option-group label="工厂">
                        <template>
                            <el-option v-for="factory in factoryList" :key="factory.id + factory.sourceType" :label="factory.name" :value="factory.id + ',' + factory.sourceType"> </el-option>
                        </template>
                    </el-option-group>
                    <el-option-group label="门店">
                        <template>
                            <el-option v-for="store in storeList" :key="store.id + store.sourceType" :label="store.name" :value="store.id + ',' + store.sourceType"> </el-option>
                        </template>
                    </el-option-group>
                </el-select>
            </el-form-item>
            <el-form-item prop="name">
                <el-input v-model="queryParams.name" placeholder="请输入挂架名称" clearable @keyup.enter.native="handleQuery" />
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
                <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button type="primary" plain icon="el-icon-plus" @click="handleAdd" v-hasPermi="['cloth:hanger:add']" v-if="userInfoVO.userType != '00'">新增</el-button>
            </el-col>
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <Page uri="/mapi/cloth/hanger/list" :request-params="queryParams" ref="pagination">
            <el-table-column label="编号" align="center" prop="id" />
            <el-table-column label="挂架名称" align="center" prop="name" />
            <el-table-column label="首数" align="center" prop="firstNum" />
            <el-table-column label="尾数" align="center" prop="endNum" />
            <el-table-column label="是否长挂架" align="center" prop="isLongHanger">
                <template slot-scope="scope">
                    <dict-tag :options="dict.type.sys_yes_no" :value="scope.row.isLongHanger" />
                </template>
            </el-table-column>
            <el-table-column label="工厂/门店名称" align="center" v-if="userInfoVO.userType == '00'">
                <template slot-scope="scope">
                    <span v-if="scope.row.sourceType == '01'">工厂- {{ scope.row.factoryName }}</span>
                    <span v-if="scope.row.sourceType == '02'">门店- {{ scope.row.storeName }}</span>
                </template>
            </el-table-column>
            <el-table-column label="状态" align="center" prop="status">
                <template slot-scope="scope">
                    <el-switch v-model="scope.row.status" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
                </template>
            </el-table-column>
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="150">
                <template slot-scope="scope">
                    <el-button type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['cloth:hanger:edit']" v-if="userInfoVO.userType != '00'">修改</el-button>
                    <el-button type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['cloth:hanger:remove']" v-if="userInfoVO.userType != '00'">删除</el-button>
                    <el-button type="text" icon="el-icon-s-shop" @click="hangerDetail(scope.row)" v-hasPermi="['cloth:hanger:list']">位置详情</el-button>
                </template>
            </el-table-column>
        </Page>

        <!-- 添加或修改挂架管理对话框 -->
        <el-dialog :title="title" :visible.sync="open" size="30%" append-to-body>
            <el-row :gutter="15">
                <el-form ref="form" :model="form" :rules="rules" label-width="100px">
                    <el-col :span="24">
                        <el-form-item label="挂架名称" prop="name">
                            <el-input v-model="form.name" placeholder="请输入挂架名称" maxlength="20" show-word-limit />
                        </el-form-item>
                        <el-form-item label="首数" prop="firstNum">
                            <el-input-number v-model="form.firstNum" :step="10" :min="0" :max="1000" />
                        </el-form-item>
                        <el-form-item label="尾数" prop="endNum">
                            <el-input-number v-model="form.endNum" :step="10" :min="1" :max="1000" />
                        </el-form-item>
                        <el-form-item label="是否长挂架" prop="isLongHanger">
                            <el-radio-group v-model="form.isLongHanger" size="small">
                                <el-radio-button v-for="dict in dict.type.sys_yes_no" :label="dict.value" :key="dict.code">{{ dict.label }}</el-radio-button>
                            </el-radio-group>
                        </el-form-item>
                    </el-col>
                </el-form>
            </el-row>

            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm" style="margin-left: 5%">提交</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
import { listHanger, getHanger, delHanger, addHanger, updateHanger, updateHangerStatus } from '@/api/cloth/hanger'
import { allOrg } from '@/api/system/store'

export default {
    name: 'Hanger',
    dicts: ['sys_yes_no', 'sys_normal_disable'],
    data() {
        return {
            userInfoVO: null,
            orgList: [],
            storeList: [],
            factoryList: [],
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 挂架管理表格数据
            hangerList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 查询参数
            queryParams: {
                storeName: null,
                factoryName: null,
                orgIndex: null,
                name: null
            },
            // 表单参数
            form: {},
            // 表单校验
            rules: {
                name: [
                    {
                        required: true,
                        message: '挂架名称不能为空',
                        trigger: 'blur'
                    }
                ],
                firstNum: [
                    {
                        required: true,
                        message: '首数不能为空',
                        trigger: 'blur'
                    }
                ],
                endNum: [
                    {
                        required: true,
                        message: '尾数不能为空',
                        trigger: 'blur'
                    }
                ],
                isLongHanger: [
                    {
                        required: true,
                        message: '不能为空',
                        trigger: 'blur'
                    }
                ]
            }
        }
    },
    created() {
        this.handleUser()
        allOrg().then((res) => {
            this.orgList = res.data
            this.orgList.forEach((org) => {
                if (org.sourceType == '01') {
                    this.factoryList.push(org)
                } else {
                    this.storeList.push(org)
                }
            })
        })
        this.getList()
    },
    methods: {
        handleUser() {
            this.userInfoVO = this.getUserInfo()
        },
        /** 查询挂架管理列表 */
        getList() {
            if (this.queryParams.orgIndex != null) {
                this.queryParams.orgId = this.queryParams.orgIndex.split(',')[0]
                this.queryParams.sourceType = this.queryParams.orgIndex.split(',')[1]
            } else {
                delete this.queryParams.orgId
                delete this.queryParams.sourceType
            }

            this.$nextTick(() => {
                this.$refs.pagination.handleSearch(true)
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                orgId: null,
                sourceType: null,
                name: null,
                firstNum: null,
                endNum: null,
                isLongHanger: null,
                status: '0',
                delFlag: null,
                createById: null,
                createBy: null,
                createTime: null,
                updateById: null,
                updateBy: null,
                updateTime: null,
                remark: null
            }
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.queryParams.pageNum = 1
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm('queryForm')
            this.handleQuery()
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加挂架管理'
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id = row.id || this.ids
            getHanger(id).then((response) => {
                this.form = response.data
                this.open = true
                this.title = '修改挂架管理'
            })
        },
        /** 提交按钮 */
        submitForm() {
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    if (this.form.id != null) {
                        updateHanger(this.form).then((response) => {
                            this.$modal.msgSuccess('修改成功')
                            this.open = false
                            this.getList()
                        })
                    } else {
                        addHanger(this.form).then((response) => {
                            this.$modal.msgSuccess('新增成功')
                            this.open = false
                            this.getList()
                        })
                    }
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids
            this.$modal
                .confirm('是否确认删除挂架管理编号为"' + ids + '"的数据项？')
                .then(function () {
                    return delHanger(ids)
                })
                .then(() => {
                    this.getList()
                    this.$modal.msgSuccess('删除成功')
                })
                .catch(() => {})
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'mapi/cloth/hanger/export',
                {
                    ...this.queryParams
                },
                `hanger_${new Date().getTime()}.xlsx`
            )
        },
        checkClose(done) {
            this.$confirm('是否关闭表单，关闭后数据将丢失？')
                .then(function () {
                    done()
                })
                .then(() => {})
                .catch(() => {})
        },
        handleStatusChange(row) {
            let text = row.status === '0' ? '启用' : '停用'
            this.$confirm('确认要' + text + ' 编号' + row.id + ' 吗？')
                .then(function () {
                    return updateHangerStatus(row.id, row.status)
                })
                .then(() => {
                    this.$modal.msgSuccess(text + '成功')
                })
                .catch(function () {
                    row.status = row.status === '0' ? '1' : '0'
                })
        },
        /** 位置详情 */
        hangerDetail(row) {
            this.$tab.openPage(row.name + '的位置', '/hanger/detail/' + row.id)
        }
    }
}
</script>
